diff --git a/gdb/testsuite/gdb.ada/O2_float_param.exp b/gdb/testsuite/gdb.ada/O2_float_param.exp
index 062a27572f5..f34dc86b0bc 100644
--- a/gdb/testsuite/gdb.ada/O2_float_param.exp
+++ b/gdb/testsuite/gdb.ada/O2_float_param.exp
@@ -20,7 +20,7 @@ if { [skip_ada_tests] } { return -1 }
 standard_ada_testfile foo
 
 set have_xfail 0
-if { [is_aarch64_target] } then {
+if {[is_aarch64_target]} {
     if { [gcc_major_version] <= 8 } {
        set have_xfail 1
     }
diff --git a/gdb/testsuite/gdb.ada/access_tagged_param.exp b/gdb/testsuite/gdb.ada/access_tagged_param.exp
index 931c7fb12a9..2103e4b5390 100644
--- a/gdb/testsuite/gdb.ada/access_tagged_param.exp
+++ b/gdb/testsuite/gdb.ada/access_tagged_param.exp
@@ -28,7 +28,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug]] != "" }
 
 clean_restart ${testfile}
 
-if ![runto "foo"] then {
+if {![runto "foo"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/addr_arith.exp b/gdb/testsuite/gdb.ada/addr_arith.exp
index 35a45c9f7c7..4e3059fcfae 100644
--- a/gdb/testsuite/gdb.ada/addr_arith.exp
+++ b/gdb/testsuite/gdb.ada/addr_arith.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "START" ${testdir}/foo_na07_019.adb]
-if ![runto "foo_na07_019.adb:$bp_location" ] then {
+if {![runto "foo_na07_019.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/arr_acc_idx_w_gap.exp b/gdb/testsuite/gdb.ada/arr_acc_idx_w_gap.exp
index 0e20c5c4b2d..ac720ffa4d3 100644
--- a/gdb/testsuite/gdb.ada/arr_acc_idx_w_gap.exp
+++ b/gdb/testsuite/gdb.ada/arr_acc_idx_w_gap.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "BREAK" ${testdir}/enum_with_gap_main.adb]
-if ![runto "enum_with_gap_main.adb:$bp_location" ] then {
+if {![runto "enum_with_gap_main.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/arr_arr.exp b/gdb/testsuite/gdb.ada/arr_arr.exp
index 390a518c0c1..488eb006789 100644
--- a/gdb/testsuite/gdb.ada/arr_arr.exp
+++ b/gdb/testsuite/gdb.ada/arr_arr.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "START" ${testdir}/foo.adb]
-if ![runto "foo.adb:$bp_location" ] then {
+if {![runto "foo.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/arr_enum_idx_w_gap.exp b/gdb/testsuite/gdb.ada/arr_enum_idx_w_gap.exp
index f2c9451e0a9..3a6785fb095 100644
--- a/gdb/testsuite/gdb.ada/arr_enum_idx_w_gap.exp
+++ b/gdb/testsuite/gdb.ada/arr_enum_idx_w_gap.exp
@@ -29,7 +29,7 @@ foreach_with_prefix scenario {all minimal} {
     clean_restart ${testfile}-${scenario}
 
     set bp_location [gdb_get_line_number "BREAK" ${testdir}/foo_q418_043.adb]
-    if ![runto "foo_q418_043.adb:$bp_location" ] then {
+    if {![runto "foo_q418_043.adb:$bp_location"]} {
 	perror "Couldn't run ${testfile}-${scenario}"
 	return
     }
diff --git a/gdb/testsuite/gdb.ada/array_bounds.exp b/gdb/testsuite/gdb.ada/array_bounds.exp
index f6a39ccf6b6..b68e448747e 100644
--- a/gdb/testsuite/gdb.ada/array_bounds.exp
+++ b/gdb/testsuite/gdb.ada/array_bounds.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "START" ${testdir}/bar.adb]
-if ![runto "bar.adb:$bp_location" ] then {
+if {![runto "bar.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 } 
diff --git a/gdb/testsuite/gdb.ada/array_return.exp b/gdb/testsuite/gdb.ada/array_return.exp
index 38127cc5e1b..97ba3bc4e59 100644
--- a/gdb/testsuite/gdb.ada/array_return.exp
+++ b/gdb/testsuite/gdb.ada/array_return.exp
@@ -27,7 +27,7 @@ clean_restart ${testfile}
 
 # Start the inferior
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
@@ -68,7 +68,7 @@ gdb_test "cont" \
 # Instead, it is returned using the struct convention, and the debugger
 # unfortunately cannot find the address of the result.  The following
 # test is therefore expected to fail for all hppa targets except hppa64.
-if { ! [istarget "hppa*64*-*-*"] } then {
+if {![istarget "hppa*64*-*-*"]} {
   setup_xfail "hppa*-*-*"
 }
 
diff --git a/gdb/testsuite/gdb.ada/arrayptr.exp b/gdb/testsuite/gdb.ada/arrayptr.exp
index 6f9e2cd51a3..d8429c4413b 100644
--- a/gdb/testsuite/gdb.ada/arrayptr.exp
+++ b/gdb/testsuite/gdb.ada/arrayptr.exp
@@ -29,7 +29,7 @@ foreach_with_prefix scenario {all minimal} {
     clean_restart ${testfile}-${scenario}
 
     set bp_location [gdb_get_line_number "STOP" ${testdir}/foo.adb]
-    if ![runto "foo.adb:$bp_location" ] then {
+    if {![runto "foo.adb:$bp_location"]} {
 	perror "Couldn't run ${testfile}-${scenario}"
 	return
     }
diff --git a/gdb/testsuite/gdb.ada/bp_c_mixed_case.exp b/gdb/testsuite/gdb.ada/bp_c_mixed_case.exp
index b6dd272a79c..d6eb9f5534c 100644
--- a/gdb/testsuite/gdb.ada/bp_c_mixed_case.exp
+++ b/gdb/testsuite/gdb.ada/bp_c_mixed_case.exp
@@ -46,7 +46,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable $options] != "" } {
 
 clean_restart ${testfile}
 
-if ![runto "foo_h731_021"] then {
+if {![runto "foo_h731_021"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/bp_inlined_func.exp b/gdb/testsuite/gdb.ada/bp_inlined_func.exp
index 076e8c2425f..be13bc26516 100644
--- a/gdb/testsuite/gdb.ada/bp_inlined_func.exp
+++ b/gdb/testsuite/gdb.ada/bp_inlined_func.exp
@@ -25,7 +25,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 
 clean_restart ${testfile}
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
diff --git a/gdb/testsuite/gdb.ada/call_pn.exp b/gdb/testsuite/gdb.ada/call_pn.exp
index 6b403d4d4e7..c4f81245f92 100644
--- a/gdb/testsuite/gdb.ada/call_pn.exp
+++ b/gdb/testsuite/gdb.ada/call_pn.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "STOP" ${testdir}/foo.adb]
-if ![runto "foo.adb:$bp_location" ] then {
+if {![runto "foo.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/catch_assert_if.exp b/gdb/testsuite/gdb.ada/catch_assert_if.exp
index 76a09b6c75c..0f0ec4ddfe9 100644
--- a/gdb/testsuite/gdb.ada/catch_assert_if.exp
+++ b/gdb/testsuite/gdb.ada/catch_assert_if.exp
@@ -32,7 +32,7 @@ clean_restart ${testfile}
 set eol "\[\r\n\]+"
 set sp "\[ \t\]*"
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
@@ -60,7 +60,7 @@ gdb_test_multiple "catch exception" $msg {
 #  - continue, we should see the second failed assertion
 #  - continue, the program exits.
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
diff --git a/gdb/testsuite/gdb.ada/catch_ex.exp b/gdb/testsuite/gdb.ada/catch_ex.exp
index 0da75d17578..d8fa04015fd 100644
--- a/gdb/testsuite/gdb.ada/catch_ex.exp
+++ b/gdb/testsuite/gdb.ada/catch_ex.exp
@@ -40,7 +40,7 @@ set catch_exception_info \
 # 1. Try catching all exceptions.  #
 ####################################
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
@@ -88,7 +88,7 @@ gdb_test "continue" \
 #  - continue, we should see the unhandled Constrait_Error exception
 #  - continue, the program exits.
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
@@ -148,7 +148,7 @@ gdb_test "continue" \
 #     at any of the other exceptions that are being raised inside
 #     the program.
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
diff --git a/gdb/testsuite/gdb.ada/catch_ex_std.exp b/gdb/testsuite/gdb.ada/catch_ex_std.exp
index 2d201a77717..4d6f2a91c19 100644
--- a/gdb/testsuite/gdb.ada/catch_ex_std.exp
+++ b/gdb/testsuite/gdb.ada/catch_ex_std.exp
@@ -67,7 +67,7 @@ clean_restart ${testfile}
 # loaded for remote targets.
 gdb_load_shlib $sofile
 
-if {![runto_main]} then {
+if {![runto_main]} {
    return 0
 }
 
diff --git a/gdb/testsuite/gdb.ada/convvar_comp.exp b/gdb/testsuite/gdb.ada/convvar_comp.exp
index 1923bd785c7..6908bc2da4f 100644
--- a/gdb/testsuite/gdb.ada/convvar_comp.exp
+++ b/gdb/testsuite/gdb.ada/convvar_comp.exp
@@ -25,7 +25,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 
 clean_restart ${testfile}
 
-if ![runto "break_me" ] then {
+if {![runto "break_me"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/disc_arr_bound.exp b/gdb/testsuite/gdb.ada/disc_arr_bound.exp
index 53dc30b0379..8cbfe5d3276 100644
--- a/gdb/testsuite/gdb.ada/disc_arr_bound.exp
+++ b/gdb/testsuite/gdb.ada/disc_arr_bound.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "STOP" ${testdir}/foo_n612_026.adb]
-if ![runto "foo_n612_026.adb:$bp_location" ] then {
+if {![runto "foo_n612_026.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/discrete-char.exp b/gdb/testsuite/gdb.ada/discrete-char.exp
index 762b3def4b9..1d380e4d597 100644
--- a/gdb/testsuite/gdb.ada/discrete-char.exp
+++ b/gdb/testsuite/gdb.ada/discrete-char.exp
@@ -28,7 +28,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable {debug}] != ""} {
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "STOP" ${testdir}/main.adb]
-if {![runto "main.adb:$bp_location"]} then {
+if {![runto "main.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/dot_all.exp b/gdb/testsuite/gdb.ada/dot_all.exp
index c1f60f8ee2a..6064a7d505b 100644
--- a/gdb/testsuite/gdb.ada/dot_all.exp
+++ b/gdb/testsuite/gdb.ada/dot_all.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "STOP" ${testdir}/foo.adb]
-if ![runto "foo.adb:$bp_location" ] then {
+if {![runto "foo.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/dyn_loc.exp b/gdb/testsuite/gdb.ada/dyn_loc.exp
index 46c7edb71aa..d2cf68d1dc7 100644
--- a/gdb/testsuite/gdb.ada/dyn_loc.exp
+++ b/gdb/testsuite/gdb.ada/dyn_loc.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "BREAK" ${testdir}/pack.adb]
-if ![runto "pack.adb:$bp_location" ] then {
+if {![runto "pack.adb:$bp_location"]} {
   return -1
 }
 
diff --git a/gdb/testsuite/gdb.ada/dyn_stride.exp b/gdb/testsuite/gdb.ada/dyn_stride.exp
index d9e6c6ae0d3..dad3f0c0cbd 100644
--- a/gdb/testsuite/gdb.ada/dyn_stride.exp
+++ b/gdb/testsuite/gdb.ada/dyn_stride.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "STOP" ${testdir}/foo.adb]
-if ![runto "foo.adb:$bp_location" ] then {
+if {![runto "foo.adb:$bp_location"]} {
   return -1
 }
 
diff --git a/gdb/testsuite/gdb.ada/excep_handle.exp b/gdb/testsuite/gdb.ada/excep_handle.exp
index 9475dd607a4..ddc1886b59d 100644
--- a/gdb/testsuite/gdb.ada/excep_handle.exp
+++ b/gdb/testsuite/gdb.ada/excep_handle.exp
@@ -44,7 +44,7 @@ set catchpoint_storage_error_msg \
 # Check that runtime supports catchpoint.  #
 ############################################
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
diff --git a/gdb/testsuite/gdb.ada/frame_args.exp b/gdb/testsuite/gdb.ada/frame_args.exp
index 1a37c79f072..9961780ad39 100644
--- a/gdb/testsuite/gdb.ada/frame_args.exp
+++ b/gdb/testsuite/gdb.ada/frame_args.exp
@@ -30,7 +30,7 @@ set any_addr "0x\[0-9a-zA-Z\]+"
 set eol "\[\r\n\]+"
 set sp "\[ \t\]*"
 
-if ![runto break_me] then {
+if {![runto break_me]} {
   perror "Couldn't run ${testfile}"
   return
 } 
diff --git a/gdb/testsuite/gdb.ada/fun_in_declare.exp b/gdb/testsuite/gdb.ada/fun_in_declare.exp
index 38802409bb1..4b30a777895 100644
--- a/gdb/testsuite/gdb.ada/fun_in_declare.exp
+++ b/gdb/testsuite/gdb.ada/fun_in_declare.exp
@@ -25,7 +25,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 
 clean_restart ${testfile}
 
-if ![runto_main] then {
+if {![runto_main]} {
   perror "Couldn't run ${testfile}"
   return
 } 
diff --git a/gdb/testsuite/gdb.ada/ghost.exp b/gdb/testsuite/gdb.ada/ghost.exp
index ece03dbe2f8..93ab507e337 100644
--- a/gdb/testsuite/gdb.ada/ghost.exp
+++ b/gdb/testsuite/gdb.ada/ghost.exp
@@ -27,7 +27,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable $flags] != "" } {
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "START" ${testdir}/main.adb]
-if ![runto "main.adb:$bp_location" ] then {
+if {![runto "main.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/info_addr_mixed_case.exp b/gdb/testsuite/gdb.ada/info_addr_mixed_case.exp
index 0a63873df24..d512ef42651 100644
--- a/gdb/testsuite/gdb.ada/info_addr_mixed_case.exp
+++ b/gdb/testsuite/gdb.ada/info_addr_mixed_case.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "START" ${testdir}/foo.adb]
-if ![runto "foo.adb:$bp_location" ] then {
+if {![runto "foo.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/info_auto_lang.exp b/gdb/testsuite/gdb.ada/info_auto_lang.exp
index af882f7d8d2..9e17cf6c028 100644
--- a/gdb/testsuite/gdb.ada/info_auto_lang.exp
+++ b/gdb/testsuite/gdb.ada/info_auto_lang.exp
@@ -45,7 +45,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "STOP" ${testdir}/some_c.c]
-if ![runto "some_c.c:$bp_location"] then {
+if {![runto "some_c.c:$bp_location"]} {
     return
 }
 
diff --git a/gdb/testsuite/gdb.ada/info_exc.exp b/gdb/testsuite/gdb.ada/info_exc.exp
index 4e0059ad3dc..c0a9e4dea53 100644
--- a/gdb/testsuite/gdb.ada/info_exc.exp
+++ b/gdb/testsuite/gdb.ada/info_exc.exp
@@ -25,7 +25,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug]] != "" }
 
 clean_restart ${testfile}
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
diff --git a/gdb/testsuite/gdb.ada/local-enum.exp b/gdb/testsuite/gdb.ada/local-enum.exp
index 99bc0c94b8a..908ee73b899 100644
--- a/gdb/testsuite/gdb.ada/local-enum.exp
+++ b/gdb/testsuite/gdb.ada/local-enum.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable debug] != ""} {
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "STOP" ${testdir}/local.adb]
-if ![runto "local.adb:$bp_location" ] then {
+if {![runto "local.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/mi_catch_assert.exp b/gdb/testsuite/gdb.ada/mi_catch_assert.exp
index e586b4d7cd5..d34938fa181 100644
--- a/gdb/testsuite/gdb.ada/mi_catch_assert.exp
+++ b/gdb/testsuite/gdb.ada/mi_catch_assert.exp
@@ -34,7 +34,7 @@ set sp "\[ \t\]*"
 
 clean_restart ${testfile}
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
diff --git a/gdb/testsuite/gdb.ada/mi_catch_ex.exp b/gdb/testsuite/gdb.ada/mi_catch_ex.exp
index aeb3c388c56..3258476be56 100644
--- a/gdb/testsuite/gdb.ada/mi_catch_ex.exp
+++ b/gdb/testsuite/gdb.ada/mi_catch_ex.exp
@@ -34,7 +34,7 @@ set eol "\[\r\n\]+"
 
 clean_restart ${testfile}
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
diff --git a/gdb/testsuite/gdb.ada/mi_catch_ex_hand.exp b/gdb/testsuite/gdb.ada/mi_catch_ex_hand.exp
index 5a8e6cd71ce..9ca6688d430 100644
--- a/gdb/testsuite/gdb.ada/mi_catch_ex_hand.exp
+++ b/gdb/testsuite/gdb.ada/mi_catch_ex_hand.exp
@@ -33,7 +33,7 @@ set eol "\[\r\n\]+"
 
 clean_restart ${testfile}
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
diff --git a/gdb/testsuite/gdb.ada/mi_ex_cond.exp b/gdb/testsuite/gdb.ada/mi_ex_cond.exp
index 4de08dc6592..ddf9e0bbea7 100644
--- a/gdb/testsuite/gdb.ada/mi_ex_cond.exp
+++ b/gdb/testsuite/gdb.ada/mi_ex_cond.exp
@@ -34,7 +34,7 @@ set eol "\[\r\n\]+"
 
 clean_restart ${testfile}
 
-if ![runto_main] then {
+if {![runto_main]} {
    return 0
 }
 
diff --git a/gdb/testsuite/gdb.ada/mi_task_arg.exp b/gdb/testsuite/gdb.ada/mi_task_arg.exp
index 4713fda62fd..d80dfd47015 100644
--- a/gdb/testsuite/gdb.ada/mi_task_arg.exp
+++ b/gdb/testsuite/gdb.ada/mi_task_arg.exp
@@ -38,7 +38,7 @@ mi_gdb_load ${binfile}
 # This test won't work properly if system debuginfo is installed.
 mi_gdb_test "-gdb-set debug-file-directory \"\"" ".*"
 
-if ![mi_runto "task_switch.break_me"] then {
+if {![mi_runto "task_switch.break_me"]} {
    return 0
 }
 
diff --git a/gdb/testsuite/gdb.ada/mi_task_info.exp b/gdb/testsuite/gdb.ada/mi_task_info.exp
index 2a2a91d537e..62d0b834dca 100644
--- a/gdb/testsuite/gdb.ada/mi_task_info.exp
+++ b/gdb/testsuite/gdb.ada/mi_task_info.exp
@@ -39,7 +39,7 @@ mi_gdb_load ${binfile}
 # 1. Try catching all exceptions.  #
 ####################################
 
-if ![mi_runto "task_switch.break_me"] then {
+if {![mi_runto "task_switch.break_me"]} {
    return 0
 }
 
diff --git a/gdb/testsuite/gdb.ada/minsyms.exp b/gdb/testsuite/gdb.ada/minsyms.exp
index 1382f8ccdd8..7ce2d814475 100644
--- a/gdb/testsuite/gdb.ada/minsyms.exp
+++ b/gdb/testsuite/gdb.ada/minsyms.exp
@@ -25,7 +25,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable ""] != "" } {
 
 clean_restart ${testfile}
 
-if ![runto "_ada_foo_qb07_057" ] then {
+if {![runto "_ada_foo_qb07_057"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/mod_from_name.exp b/gdb/testsuite/gdb.ada/mod_from_name.exp
index 009e32d4dd1..8eb61565ff4 100644
--- a/gdb/testsuite/gdb.ada/mod_from_name.exp
+++ b/gdb/testsuite/gdb.ada/mod_from_name.exp
@@ -29,7 +29,7 @@ foreach_with_prefix scenario {all minimal} {
     clean_restart ${testfile}-${scenario}
 
     set bp_location [gdb_get_line_number "START" ${testdir}/foo.adb]
-    if ![runto "foo.adb:$bp_location" ] then {
+    if {![runto "foo.adb:$bp_location"]} {
 	perror "Couldn't run ${testfile}-${scenario}"
 	return
     } 
diff --git a/gdb/testsuite/gdb.ada/optim_drec.exp b/gdb/testsuite/gdb.ada/optim_drec.exp
index cccec6c2267..823156cd804 100644
--- a/gdb/testsuite/gdb.ada/optim_drec.exp
+++ b/gdb/testsuite/gdb.ada/optim_drec.exp
@@ -25,7 +25,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 
 clean_restart ${testfile}
 
-if ![runto "foo" ] then {
+if {![runto "foo"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/ptype_tagged_param.exp b/gdb/testsuite/gdb.ada/ptype_tagged_param.exp
index 3a4a84a22ce..116748ab184 100644
--- a/gdb/testsuite/gdb.ada/ptype_tagged_param.exp
+++ b/gdb/testsuite/gdb.ada/ptype_tagged_param.exp
@@ -27,7 +27,7 @@ set has_runtime_debug_info [gnat_runtime_has_debug_info]
 
 clean_restart ${testfile}
 
-if ![runto "pck.adb:20" ] then {
+if {![runto "pck.adb:20"]} {
   return -1
 }
 
diff --git a/gdb/testsuite/gdb.ada/rec_comp.exp b/gdb/testsuite/gdb.ada/rec_comp.exp
index 9205a26548c..342fe3a0e07 100644
--- a/gdb/testsuite/gdb.ada/rec_comp.exp
+++ b/gdb/testsuite/gdb.ada/rec_comp.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "STOP" ${testdir}/bar_o203_012.adb]
-if ![runto "bar_o203_012.adb:$bp_location" ] then {
+if {![runto "bar_o203_012.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/rec_return.exp b/gdb/testsuite/gdb.ada/rec_return.exp
index b68537ee41c..723244fc576 100644
--- a/gdb/testsuite/gdb.ada/rec_return.exp
+++ b/gdb/testsuite/gdb.ada/rec_return.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "STOP" ${testdir}/foo.adb]
-if ![runto "foo.adb:$bp_location" ] then {
+if {![runto "foo.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/ref_param.exp b/gdb/testsuite/gdb.ada/ref_param.exp
index 56347932564..871e755ff39 100644
--- a/gdb/testsuite/gdb.ada/ref_param.exp
+++ b/gdb/testsuite/gdb.ada/ref_param.exp
@@ -25,7 +25,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 
 clean_restart ${testfile}
 
-if ![runto pck.adb:20] then {
+if {![runto pck.adb:20]} {
   perror "Couldn't run ${testfile}"
   return
 } 
diff --git a/gdb/testsuite/gdb.ada/scalar_storage.exp b/gdb/testsuite/gdb.ada/scalar_storage.exp
index 8180e6e8bb1..106413e9528 100644
--- a/gdb/testsuite/gdb.ada/scalar_storage.exp
+++ b/gdb/testsuite/gdb.ada/scalar_storage.exp
@@ -29,7 +29,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "START" ${testdir}/storage.adb]
-if ![runto "storage.adb:$bp_location" ] then {
+if {![runto "storage.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/set_wstr.exp b/gdb/testsuite/gdb.ada/set_wstr.exp
index 9e58df25352..97a683dd37a 100644
--- a/gdb/testsuite/gdb.ada/set_wstr.exp
+++ b/gdb/testsuite/gdb.ada/set_wstr.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "STOP" ${testdir}/a.adb]
-if ![runto "a.adb:$bp_location" ] then {
+if {![runto "a.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/small_reg_param.exp b/gdb/testsuite/gdb.ada/small_reg_param.exp
index a07843d2596..cb3c3bf4b4d 100644
--- a/gdb/testsuite/gdb.ada/small_reg_param.exp
+++ b/gdb/testsuite/gdb.ada/small_reg_param.exp
@@ -25,7 +25,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug optimize=-
 
 clean_restart ${testfile}
 
-if ![runto_main] then {
+if {![runto_main]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/str_uninit.exp b/gdb/testsuite/gdb.ada/str_uninit.exp
index cda1439d48b..96862909e87 100644
--- a/gdb/testsuite/gdb.ada/str_uninit.exp
+++ b/gdb/testsuite/gdb.ada/str_uninit.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "START" ${testdir}/parse.adb]
-if ![runto "parse.adb:$bp_location" ] then {
+if {![runto "parse.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/taft_type.exp b/gdb/testsuite/gdb.ada/taft_type.exp
index 10c6f477e9c..a791cd179a6 100644
--- a/gdb/testsuite/gdb.ada/taft_type.exp
+++ b/gdb/testsuite/gdb.ada/taft_type.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "START" ${testdir}/p.adb]
-if ![runto "p.adb:$bp_location" ] then {
+if {![runto "p.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 } 
diff --git a/gdb/testsuite/gdb.ada/task_switch_in_core.exp b/gdb/testsuite/gdb.ada/task_switch_in_core.exp
index 02d60cd20e6..7a56693e656 100644
--- a/gdb/testsuite/gdb.ada/task_switch_in_core.exp
+++ b/gdb/testsuite/gdb.ada/task_switch_in_core.exp
@@ -30,7 +30,7 @@ clean_restart ${testfile}
 # testcase is to generate this core file, so we can then exercise
 # task-switching when debugging from core files.
 
-if { ![runto request_for_crash ]} then {
+if {![runto request_for_crash]} {
     untested "couldn't run to Request_For_Crash"
     return -1
 }
diff --git a/gdb/testsuite/gdb.ada/varsize_limit.exp b/gdb/testsuite/gdb.ada/varsize_limit.exp
index 5cd6d1adbd6..af5a394f38b 100644
--- a/gdb/testsuite/gdb.ada/varsize_limit.exp
+++ b/gdb/testsuite/gdb.ada/varsize_limit.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "STOP" ${testdir}/vsizelim.adb]
-if ![runto "vsizelim.adb:$bp_location" ] then {
+if {![runto "vsizelim.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }
diff --git a/gdb/testsuite/gdb.ada/whatis_array_val.exp b/gdb/testsuite/gdb.ada/whatis_array_val.exp
index 69f90e1f22b..eadd6ed2da2 100644
--- a/gdb/testsuite/gdb.ada/whatis_array_val.exp
+++ b/gdb/testsuite/gdb.ada/whatis_array_val.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "STOP" ${testdir}/foo.adb]
-if ![runto "foo.adb:$bp_location" ] then {
+if {![runto "foo.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 } 
diff --git a/gdb/testsuite/gdb.ada/widewide.exp b/gdb/testsuite/gdb.ada/widewide.exp
index 56c9e12abd2..34f5967ec04 100644
--- a/gdb/testsuite/gdb.ada/widewide.exp
+++ b/gdb/testsuite/gdb.ada/widewide.exp
@@ -26,7 +26,7 @@ if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug ]] != "" }
 clean_restart ${testfile}
 
 set bp_location [gdb_get_line_number "START" ${testdir}/foo.adb]
-if ![runto "foo.adb:$bp_location" ] then {
+if {![runto "foo.adb:$bp_location"]} {
   perror "Couldn't run ${testfile}"
   return
 }