diff --git a/gdb/testsuite/gdb.disasm/t01_mov.exp b/gdb/testsuite/gdb.disasm/t01_mov.exp
index c9efa34f7c6..2e29baccc18 100644
--- a/gdb/testsuite/gdb.disasm/t01_mov.exp
+++ b/gdb/testsuite/gdb.disasm/t01_mov.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }
diff --git a/gdb/testsuite/gdb.disasm/t02_mova.exp b/gdb/testsuite/gdb.disasm/t02_mova.exp
index 3fcb0be5e2b..67d3d5f11c6 100644
--- a/gdb/testsuite/gdb.disasm/t02_mova.exp
+++ b/gdb/testsuite/gdb.disasm/t02_mova.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }
diff --git a/gdb/testsuite/gdb.disasm/t03_add.exp b/gdb/testsuite/gdb.disasm/t03_add.exp
index 0a5a914e0c8..b2f2289f585 100644
--- a/gdb/testsuite/gdb.disasm/t03_add.exp
+++ b/gdb/testsuite/gdb.disasm/t03_add.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }
diff --git a/gdb/testsuite/gdb.disasm/t04_sub.exp b/gdb/testsuite/gdb.disasm/t04_sub.exp
index 4f4353e0df6..5ac5829d60f 100644
--- a/gdb/testsuite/gdb.disasm/t04_sub.exp
+++ b/gdb/testsuite/gdb.disasm/t04_sub.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }
diff --git a/gdb/testsuite/gdb.disasm/t05_cmp.exp b/gdb/testsuite/gdb.disasm/t05_cmp.exp
index 534f81650db..a1c704151c9 100644
--- a/gdb/testsuite/gdb.disasm/t05_cmp.exp
+++ b/gdb/testsuite/gdb.disasm/t05_cmp.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }
diff --git a/gdb/testsuite/gdb.disasm/t06_ari2.exp b/gdb/testsuite/gdb.disasm/t06_ari2.exp
index ab5ffdd5fa0..c7de7336217 100644
--- a/gdb/testsuite/gdb.disasm/t06_ari2.exp
+++ b/gdb/testsuite/gdb.disasm/t06_ari2.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }
diff --git a/gdb/testsuite/gdb.disasm/t07_ari3.exp b/gdb/testsuite/gdb.disasm/t07_ari3.exp
index 810dc0e2311..7937925e70a 100644
--- a/gdb/testsuite/gdb.disasm/t07_ari3.exp
+++ b/gdb/testsuite/gdb.disasm/t07_ari3.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }
diff --git a/gdb/testsuite/gdb.disasm/t08_or.exp b/gdb/testsuite/gdb.disasm/t08_or.exp
index 5ade4eb770e..fdfa0a1b301 100644
--- a/gdb/testsuite/gdb.disasm/t08_or.exp
+++ b/gdb/testsuite/gdb.disasm/t08_or.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }
diff --git a/gdb/testsuite/gdb.disasm/t09_xor.exp b/gdb/testsuite/gdb.disasm/t09_xor.exp
index 8c8f584e136..7e246753367 100644
--- a/gdb/testsuite/gdb.disasm/t09_xor.exp
+++ b/gdb/testsuite/gdb.disasm/t09_xor.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }
diff --git a/gdb/testsuite/gdb.disasm/t10_and.exp b/gdb/testsuite/gdb.disasm/t10_and.exp
index c096737019f..5650aebba1c 100644
--- a/gdb/testsuite/gdb.disasm/t10_and.exp
+++ b/gdb/testsuite/gdb.disasm/t10_and.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }
diff --git a/gdb/testsuite/gdb.disasm/t11_logs.exp b/gdb/testsuite/gdb.disasm/t11_logs.exp
index 7511b84c28d..2b58273c307 100644
--- a/gdb/testsuite/gdb.disasm/t11_logs.exp
+++ b/gdb/testsuite/gdb.disasm/t11_logs.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }
diff --git a/gdb/testsuite/gdb.disasm/t12_bit.exp b/gdb/testsuite/gdb.disasm/t12_bit.exp
index 1020986f331..e58412128f3 100644
--- a/gdb/testsuite/gdb.disasm/t12_bit.exp
+++ b/gdb/testsuite/gdb.disasm/t12_bit.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }
diff --git a/gdb/testsuite/gdb.disasm/t13_otr.exp b/gdb/testsuite/gdb.disasm/t13_otr.exp
index 70fbd1310e1..61b300f511f 100644
--- a/gdb/testsuite/gdb.disasm/t13_otr.exp
+++ b/gdb/testsuite/gdb.disasm/t13_otr.exp
@@ -30,12 +30,12 @@ set asm-flags ""
 set link-flags "-m h8300sxelf"
 
 
-if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} then {
+if {[target_assemble $srcfile $objfile "${asm-flags}"] != ""} {
      untested "failed to assemble"
      return -1
 }
 
-if {[target_link $objfile $binfile "${link-flags}"] != ""} then {
+if {[target_link $objfile $binfile "${link-flags}"] != ""} {
      untested "failed to link"
      return -1
 }